import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:surveytest/svg.dart';

class BottomNavigation extends StatefulWidget {
  final Function? onClickNext;
  final Function? onClickPrevious;
  const BottomNavigation({Key? key, this.onClickNext, this.onClickPrevious})
      : super(key: key);

  @override
  State<BottomNavigation> createState() => _BottomNavigationState(
        onClickNext: this.onClickNext,
        onClickPrevious: this.onClickPrevious,
      );
}

class _BottomNavigationState extends State<BottomNavigation> {
  final Function? onClickNext;
  final Function? onClickPrevious;

  _BottomNavigationState({this.onClickNext, this.onClickPrevious});
  @override
  Widget build(BuildContext context) {
    return Container(
      width: double.infinity,
      color: Color.fromRGBO(247, 247, 247, 1),
      child: Container(
        margin: EdgeInsets.only(left: 10.0, right: 10.0, bottom: 20.0),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            SvgPicture.string(footerSVG),
            Container(
              child: Row(
                mainAxisAlignment: MainAxisAlignment.center,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  IconButton(
                      iconSize: 42,
                      onPressed: () {
                        if (onClickPrevious != null) {
                          onClickPrevious!();
                        }
                        print("previous called");
                      },
                      icon: SvgPicture.string(upArrow)),
                  IconButton(
                      iconSize: 42,
                      onPressed: () {
                         if (onClickNext != null) {
                          onClickNext!();
                        }
                        print("next called");
                      },
                      icon: SvgPicture.string(downArrow)),
                ],
              ),
            ),
          ],
        ),
      ),
    );
  }
}
