import 'package:flutter/material.dart';

import '../helpers/question.dart';

class QuestionColumn extends StatefulWidget {
  final Map<dynamic, dynamic> question;
  final int currentQuestionNumber;
  final Map<String, String> customParams;
  final Map<dynamic, dynamic> theme;
  const QuestionColumn({
    Key? key,
    required this.question,
    required this.currentQuestionNumber,
    required this.theme,
    required this.customParams,
  }) : super(key: key);

  @override
  State<QuestionColumn> createState() => _QuestionColumnState(
        question: question,
        currentQuestionNumber: currentQuestionNumber,
        theme: this.theme,
        customParams: this.customParams,
      );
}

class _QuestionColumnState extends State<QuestionColumn> {
  final Map<dynamic, dynamic> question;
  final int currentQuestionNumber;
  final Map<dynamic, dynamic> theme;
  final Map<String, String> customParams;
  _QuestionColumnState({
    required this.question,
    required this.currentQuestionNumber,
    required this.theme,
    required this.customParams,
  });

  @override
  Widget build(BuildContext context) {
    print("obtained theme is 0091 ${theme}");
    return Container(
      width: double.infinity,
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text(
            'Question ${currentQuestionNumber.toString()}',
            textAlign: TextAlign.left,
            style: TextStyle(
              decoration: TextDecoration.none,
              fontSize: 14,
              fontWeight: FontWeight.w400,
              color: theme['questionNumberColor'],
            ),
          ),
          SizedBox(height: 8),
          Text(
            parsedHeading(this.question,this.customParams),
            textAlign: TextAlign.left,
            style: TextStyle(
                decoration: TextDecoration.none,
                fontSize: 22,
                fontWeight: FontWeight.w400,
                color: theme['questionColor']),
          ),
          Text(
            this.question['rdesc']['blocks'][0]['text'],
            textAlign: TextAlign.left,
            style: TextStyle(
              decoration: TextDecoration.none,
              fontSize: 16,
              fontWeight: FontWeight.w400,
              color: theme['questionDescriptionColor'],
            ),
          ),
          SizedBox(height: 40),
        ],
      ),
    );
  }
}
